#ifndef _PFE_SHELL_OS_EXT_H
#define _PFE_SHELL_OS_EXT_H 974444598
/* generated 2000-1117-0703 ../../pfe/Make-H.pl ../../pfe/shell-os-ext.c */

#include <pfe/incl-ext.h>

/** 
 * -- os-like / shell-like commands for pfe
 * 
 *  Copyright (C) Tektronix, Inc. 1998 - 2000. All rights reserved.
 *
 *  @see     GNU LGPL
 *  @author  Tektronix CTE         @(#) %derived_by: guidod %
 *  @version %version: 5.3 %
 *    (%date_modified: Mon Sep 18 17:56:30 2000 %)
 *
 *  @description
 *        These builtin words are modelled after common shell commands,
 *        so that the Portable Forth Environment can often 
 *        be put in the place of a normal OS shell.
 */

#ifdef __cplusplus
extern "C" {
#endif




/**
 * calls system's <c> getpid </c>
 */
extern P4_CODE (p4_getpid);

/**
 * calls system's <c> getuid </c>
 */
extern P4_CODE (p4_getuid);

/**
 * calls system's <c> geteuid </c>
 */
extern P4_CODE (p4_geteuid);

/**
 * calls system's <c> getgid </c>
 */
extern P4_CODE (p4_getgid);

/**
 * calls system's <c> umask </c>
 */
extern P4_CODE (p4_umask);

/**
 * calls system's <c> getenv(HOME) </c>
 */
extern P4_CODE (p4_home);

/**
 * calls system's <c> getenv(USER) </c>
 */
extern P4_CODE (p4_user);

/**
 * calls system's <c> getcwd </c>
 */
extern P4_CODE (p4_cwd);

/**
 * calls system's <c> getcwd </c> and prints it to the screen
 */
extern P4_CODE (p4_pwd);

extern P4_CODE (p4_chdir);

#ifdef __cplusplus
} /* extern "C" */
#endif


#endif
